## FRR 动态路由



FRR 动态路由软件包 组件

这些配置行似乎来自于某种网络服务或路由器的配置文件，每一行都代表对一个特定的网络守护进程(daemon)的启用（yes）或禁用（no）设置。

- `bgpd=no`：表示边界网关协议（BGP）守护进程被禁用。
- `ospfd=no`：表示开放最短路径优先（OSPF）守护进程被禁用。
- `#ospfd_instances=1,20`：这行以`#`开始，表示它是一个注释，不会被执行。如果启用，它可能用于指定OSPF守护进程的实例数量或特定的实例ID。
- `ospf6d=no`：表示用于IPv6的OSPF守护进程被禁用。
- `ripd=no`：表示路由信息协议（RIP）守护进程被禁用。
- `ripngd=no`：表示用于IPv6的RIP新一代（RIPng）守护进程被禁用。
- `isisd=no`：表示中间系统到中间系统（IS-IS）守护进程被禁用。
- `pimd=no`：表示协议独立组播（PIM）守护进程被禁用。
- `ldpd=no`：表示标签分发协议（LDP）守护进程被禁用。
- `nhrpd=no`：表示下一代路由解析协议（NHRP）守护进程被禁用。
- `eigrpd=no`：表示增强内部网关路由协议（EIGRP）守护进程被禁用。
- `babeld=no`：表示Babel路由协议守护进程被禁用。
- `sharpd=no`：可能是一个特定网络服务的守护进程，但通常不是一个标准的路由协议守护进程。可能用于测试或特定功能。
- `pathd=no`：可能关联于路径计算元素协议（PCEP）或其他路径管理服务，用于网络路径计算和管理。
- `pbrd=no`：表示策略基路由（PBR）守护进程被禁用。
- `bfdd=no`：表示双向转发检测（BFD）守护进程被禁用。
- `fabricd=no`：可能指网络织物守护进程，用于管理数据中心网络织物的配置和操作，但在标准网络协议中不常见。
- `vrrpd=no`：表示虚拟路由器冗余协议（VRRP）守护进程被禁用。







rip 配置



```bash
router rip
 network 192.168.123.0/24
 network 192.168.192.0/24
!

interface eth0
 ip rip send version 2
 ip rip receive version 2
!

interface eth1
 ip rip send version 2
 ip rip receive version 2
```



第一段申明一个rip  路由

宣告两个子网  

```
 network 192.168.123.0/24
 network 192.168.192.0/24
 #静态路由
 route 10.147.17.0/24
```



申请监听来自那个接口的 rip 路由包

```
interface eth0
 ip rip send version 2
 ip rip receive version 2
!
```



`ip rip send version 2` 发送V2协议包

`ip rip receive version 2` 接收V2协议包